#ifndef h_libhash_h
# define h_libhash_h 1
# ifdef __cplusplus
    extrn "C" {
# endif
# include <string.h>
# include <stddef.h>

  /* These are all hash functions.  The ones that have a lgh
     parameter can handle arbitrary binary data.  The others
     expect to handle string data.  The ones that end in
     'shft' probably have the same code as those that in in
     hsh, dependant on the compiler optimizer efficiency.
     They should definitely create the same results.

     The purpose of this little package is to make it convenient
     to test hash table performance with various hash functions.
  */
  unsigned long sfh_ph(const char *data, size_t lgh);
  unsigned long ssfh_ph(const char *data);
  unsigned long x31hsh(const char *data, size_t lgh);
  unsigned long x31shft(const char *data, size_t lgh);
  unsigned long sx31hsh(const char *data);
  unsigned long sx31shft(const char *data);
  unsigned long x33hsh(const char *data, size_t lgh);
  unsigned long x33shft(const char *data, size_t lgh);
  unsigned long sx33hsh(const char *data);
  unsigned long sx33shft(const char *data);
  unsigned long x37hsh(const char *data, size_t lgh);
  unsigned long sx37hsh(const char *data);

# ifdef __cplusplus
    }
# endif
#endif /* h_libhash_h */
